﻿########################################################################
#第1章
# Working directorは 'toyoda' に指定してください。その確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))

#表1.1 測定結果(日数)
#抗原検査データ
x<-c(
11.5, 14.0, 15.0, 10.0, 14.0, 14.5, 12.5, 12.5, 12.5, 12.0, 
13.0, 12.0, 12.5, 13.5, 15.0, 13.5, 12.5, 12.0, 12.0, 17.0)

#表1.2 「抗原検査」の度数分布表(階級幅1 日)
(xs10<-seq(9.5,17.5,1))             #階級
(xt<-table(cut(x,xs10,right =F)))   #度数
(xp<-xt/length(x))                  #確率
cumsum(xt)                          #累積度数
cumsum(xp)                          #累積確率

#図1.1 ヒストグラム，左図は階級幅1 日，右図は階級幅0.5 日
par(mfrow=c(1,2))
xs05<-seq(9.75,17.25,0.5);
 hist(x,xs10,xlab="日数",ylab="",col=4,right =F,main="",cex.lab=2,cex.axis=2)
 hist(x,xs05,xlab="日数",ylab="",col=2,right =F,main="",cex.lab=2,cex.axis=2)
par(mfrow=c(1,1))
#dev.copy2eps(file="z01hist01.eps",family="Japan1")

#「抗原検査」要約統計量(積率系)　1.1.5  1.1.6
mean(x)                               #平均値
round(s2<-van(x),3)                   #分母がnの分散  
round(s<-sqrt(s2),3)                  #標準偏差

#「抗原検査」要約統計量(分位系)　1.1.7  1.1.8  1.1.9
sort(x)                               #小さい順に並べる
median(x)                             #中央値
quantile(x,0.3,type =1)               #30％点
quantile(x,0.7,type =1)               #70％点
                                      #最頻値はヒストグラム参照

#確率分布関数                       1.2.7
round(pnorm(12.5,13.075,1.502),3)

#任意の区間でデータが観察される確率 1.2.9
round(pnorm(12.0,13.075,1.502),3)
round(pnorm(10.0,13.075,1.502),3)
round(pnorm(12.0,13.075,1.502)-pnorm(10.0,13.075,1.502),3)

#95％予測区間                       1.2.10
round(13.075- 1.96*1.502, 3)
round(13.075+ 1.96*1.502, 3)

########################################################################
#第1章実習課題
#表1.3 測定結果(秒) (「知覚時間」のデータ入力)
y<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)

#　度数分布表
(ys50<-seq(24.5,35.5,1))            #階級値
(yt<-table(cut(y,ys50,right =F)))   #度数
(yp<-yt/length(y))                  #確率
cumsum(yt)                          #累積度数
cumsum(yp)                          #累積確率

#　ヒストグラム
par(mfrow=c(1,2))
ys50<-seq(24.5,36.5,1); hist(y,ys50,xlab="時間(秒)",col=4,right =F)
ys25<-seq(24,36,2); hist(y,ys25,xlab="時間(秒)",col=2,right =F)
par(mfrow=c(1,1))

#「知覚時間」要約統計量(積率系)　
mean(y)                               #平均値
round(ys2<-van(y),3)                  #分母がnの分散
round(ys<-sqrt(ys2),3)                #標準偏差

#「知覚時間」要約統計量(分位系)　
sort(y)                               #小さい順に並べる
median(y)                             #中央値
quantile(y,0.3,type =1)               #30％点
quantile(y,0.7,type =1)               #70％点


########################################################################
#第1章実践問題
期末試験<-scan("scrJ/期末試験.dat")
男性の年収<-scan("scrJ/男性の年収.dat")
間欠泉の待ち時間<-scan("scrJ/間欠泉.dat")

par(mfrow=c(3,1))
hist(期末試験,xlim=c(40,100),breaks=30,main="",
  xlab="「心理統計法」の期末試験のテスト得点",ylab="",
  cex.axis=2.0,cex.lab=2.0);
hist(男性の年収,xlim=c(0,2000),breaks=30,main="",
  xlab="平成26年度の男性の年収(万円)",ylab="",cex.axis=2.0,cex.lab=2.0);
hist(間欠泉の待ち時間,breaks=30,main="",
  xlab="噴出から次の噴出までの間欠泉の待ち時間（分）",
  ylab="",cex.axis=2.0,cex.lab=2.0)
par(mfrow=c(1,1))
#dev.copy2eps(file="z04hist001.eps",family="Japan1")



#自習
#	1. 期末試験の平均値と中央値は？   最頻値は97点
#	2. 男性の年収の平均値と中央値は？　90%、95%、99%点は？ 最頻値は350万円
#	3. 間欠泉の平均値と中央値は？　（最頻値は 53 分、77 分）


########################################################################
