﻿########################################################################
#第3章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し
   library(bayesplot)             #パッケージbayesplotの呼び出し

#表1.1 測定結果(日数)
#抗原検査データ
x<-c(
11.5, 14.0, 15.0, 10.0, 14.0, 14.5, 12.5, 12.5, 12.5, 12.0, 
13.0, 12.0, 12.5, 13.5, 15.0, 13.5, 12.5, 12.0, 12.0, 17.0)

#G1meanは、正規分布に関する推測、xはベクトル形式のデータ、
#   priorはTなら事前分布の範囲を指定。Fなら指定せず(stanにまかせる)
out0301 <-G1mean(x,prior=F)

#save(out0301,  file="./scrJ/obje/out0301")
#load(file="./scrJ/obje/out0301"); #予めMCMCした結果をロード

#図3.1 平均μ (上段) と標準偏差σ (下段) のトレースプロット
mcmc_trace(out0301$draw,pars ="mu" )
mcmc_trace(out0301$draw,pars ="sigma" )
#dev.copy2eps(file="z02traceplot.eps",family="Japan1")

#表3.1 乱数列の評価
#表3.2 「抗原検査」の母数の推定結果
gqcal(out0301$ext[,1:3])
summary(out0301$draw)

#図3.3 平均μの事後分布
hist(out0301$mu,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02mu_density.eps",family="Japan1")

#図3.4 標準偏差σの事後分布
hist(out0301$sigma,breaks=150,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02estimator.eps",family="Japan1")

#図3.5 事後予測分布
hist(out0301$xaste,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02prediction.eps",family="Japan1")

#EAPによる条件付き予測分布の上限下限
round(13.07- 1.96*1.65, 2)
round(13.07+ 1.96*1.65, 2)


########################################################################
#第3章 3.6 演習課題 p.46
#表1.3 測定結果(秒) (「知覚時間」のデータ入力)
y<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)

#正規分布に関する推測
out0302 <-G1mean(y,prior=F)#正規分布に関する推測
#save(out0302,  file="./scrJ/obje/out0302")
#load(file="./scrJ/obje/out0302"); #予めMCMCした結果をロード

#図3.1,表3.2相当
mcmc_trace(out0302$draw,pars ="mu" )
mcmc_trace(out0302$draw,pars ="sigma" )
gqcal(out0302$ext[,1:3])
summary(out0302$draw)

hist(out0302$mu,breaks=100)       #図3.3相当の 平均の事後分布
hist(out0302$sigma,breaks=100)    #図3.4相当の sdの事後分布
hist(out0302$xaste,breaks=100)    #図3.5相当の 事後予測分布


########################################################################
#自習　第3章 3.7 実践問題 p.47
#１）表3.2に相当する母数の推定結果を、データBで計算して、以下に示せ。
#２）データAとBのμEAPを比較し、効果を比較し、評価・解釈せよ。
#３）データAとBのσEAPを比較し、性質を比較し、評価・解釈せよ。
#４）陰性になるまでの日数が、投薬しない場合の平均日数15日より長くなる確率を、
#    それぞれ新薬AとBで計算し、確率を比較し、どちらが優秀か判定せよ。

xB<-scan("scrJ/抗原検査B.dat",sep="")

out0303 <-G1mean(xB,prior=F)#正規分布に関する推測
#save(out0303,  file="./scrJ/obje/out0303")
#load(file="./scrJ/obje/out0303"); #予めMCMCした結果をロード

# 1), 2), 3)　表3.2相当 
gqcal(out0303$ext[,1:3])
summary(out0303$draw)

# 4) ヒント：μとσの点推定値を利用して、教科書p.31,2.6 実習課題　2)のスクリプトを利用する。
#　　　　1—F（15|μ,σ） を評価する。　分布関数の接頭語は何だったかな？

########################################################################

#瀕死の統計学を救え 第1章 1.4 2項検定 p.11
#「未来の予感」の検定結果　Bem(2011)の再分析##############

z <- 829 ;  n <- 1560;                              #正反応数と試行数 
binom.test(z,n,p=0.5);                              #２項分布を使った検定

#「念力実験」をしてみよう
z <-53100;  n<-100000;                              #正反応数と試行数 
binom.test(z,n,p=0.5);                              #2項分布で正確に検定
