﻿########################################################################
#第4章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表1.1 測定結果(日数)
#抗原検査データ
x<-c(
11.5, 14.0, 15.0, 10.0, 14.0, 14.5, 12.5, 12.5, 12.5, 12.0, 
13.0, 12.0, 12.5, 13.5, 15.0, 13.5, 12.5, 12.0, 12.0, 17.0)

#正規分布に関する推測
out0301 <-G1mean(x,prior=F)
#save(out0301,  file="./scrJ/obje/out0301")
#load(file="./scrJ/obje/out0301"); #予めMCMCした結果をロード

#乱数の取り出し
mu<-out0301$mu
sigma<-out0301$sigma

#(4.2)式　標準偏差の事後分布に従う乱数とその2乗
bunsan <-sigma^2
round( sigma[1:7],3)
round(bunsan[1:7],3)

#4.2.1　分散　(4.2)式
max(bunsan)

#4.2.2 平均の2 乗は，2 乗の平均に一致しない  (4.4)式
round(mean(bunsan)  ,3)
round(mean(sigma)^2 ,3)

#4.2.3 50%点の2 乗は2 乗の50%点に一致する  (4.5)式
round(median(bunsan)      ,3)
round(median(sigma)^2 ,3)

#4.2.5　変動係数　(4.6)式,(4.7)式
hendou <-sigma/mu

#表4.1 gqcal(x)は生成量の数値要約。xは事後分布を近似する生成量の乱数ベクトル
#  または（乱数×生成量）の行列、ここは、初出なので行列で例示
gqcal(cbind(bunsan,sigma,hendou)); #分散・標準偏差・変動係数


#4.3.1 基準点と平均値の差　(4.8)式,(4.9)式
sa15<-15-mu

#4.3.2 標準化された基準点と平均値の差　(4.10)式,(4.11)式
delta15<-(mu-15.0)/sigma

#4.3.3 分位点・%点  (4.12)式,(4.13)式
quarter3<-mu+0.675*sigma;        #75%点

#4.3.4 特定区間での観測確率 (4.14)式,(4.15)式
yosokbu<- 1-pnorm(15.0,mu,sigma)

#4.3.5 基準点と平均の比 (4.16)式,(4.17)式
hirit15mu<-mu/15


#表4.2 基準点のある生成量の数値要約（ベクトルで例示）
gqcal(sa15 )     #基準点15日と平均値の差        (4.8)式
gqcal(delta15)   #標準化された基準点と平均値の差(4.10)式
gqcal(quarter3)  #第3四分位                     (4.12)式,(4.13)式
gqcal(yosokbu)   #15日以後に陰性になる確率      (4.14)式,(4.15)式
gqcal(hirit15mu) #15日に対する平均の比          (4.16)式,(4.17)式

#表4.2 を　まとめて作表
gqcal(cbind(sa15,delta15,quarter3,yosokbu,hirit15mu))

#図4.1　分散事後分布
hist(bunsan ,breaks=200,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02variance.eps",family="Japan1")

#図4.2　変動係数事後分布
hist(hendou ,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02cv.eps",family="Japan1")

#図4.3　d15事後分布
hist(sa15 ,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="zsa15.eps",family="Japan1")

#図4.4　δ15事後分布
hist(delta15,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02delta15.eps",family="Japan1")

#図4.5　第3四分位事後分布
hist(quarter3,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02buniten.eps",family="Japan1")

#図4.6　特定区間での観測確率の事後分布
hist(yosokbu,breaks=100,cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02kukanpro.eps",family="Japan1")

#図4.7　基準点と平均値の比の事後分布
hist(hirit15mu,breaks=200,xlim=c(0.8,1.0),
cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="")
#dev.copy2eps(file="z02kijyunhimu115.eps",family="Japan1")

########################################################################
#第4章 4.5 実習課題  p.60
#表1.3 測定結果(秒) (「知覚時間」のデータ入力)
y<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)

#正規分布に関する推測
out0302 <-G1mean(y,prior=F)#正規分布に関する推測
#save(out0302,  file="./scrJ/obje/out0302")
#load(file="./scrJ/obje/out0302"); #予めMCMCした結果をロード

#生成量の計算
bunsan <-out0302$sigma^2
hendou <-out0302$sigma/out0302$mu
delta30<-(out0302$mu-30)/out0302$sigma
quarter<-out0302$mu-0.675*out0302$sigma
yosokbu<-pnorm(30.5,out0302$mu,out0302$sigma)-pnorm(29.5,out0302$mu,out0302$sigma)
hirit30<-out0302$xaste/30

#　生成量の推定結果(分布の要約) 
gqcal(bunsan )#分散
gqcal(hendou )#変動係数
gqcal(delta30)#デルタ30
gqcal(quarter)#第1四分位
gqcal(yosokbu)#29.5秒<y<30.5秒のデータが観察される確率
gqcal(hirit30)#85gに対する比

#各種事後分布
hist(bunsan ,breaks=100)
hist(hendou ,breaks=100)
hist(delta30,breaks=100)
hist(quarter,breaks=100)
hist(yosokbu,breaks=100)
hist(hirit30,breaks=100)



#自習1 #######################################################################
#第4章 4.6 実践問題 p.60
#以下のRQ. の観点から、「新薬Ａ」と「新薬Ｂ」の性質を比較しなさい
#[RQ.8] 基準点15日と平均値の差の点推定・区間推定
#[RQ.11] 陰性になるまでに15日以上を要する確率の点推定・区間推定

xB<-scan("scrJ/抗原検査B.dat",sep="")
out0303 <-G1mean(xB,prior=F)
#save(out0303,  file="./scrJ/obje/out0303")
#load(file="./scrJ/obje/out0303"); #予めMCMCした結果をロード

#生成量の計算
sa15B<-15-out0303$mu
yosokbuB<- 1-pnorm(15.0,out0303$mu,out0303$sigma)

#生成量の推定結果(分布の要約) 新薬B
gqcal(sa15B )    #基準点15日と平均値の差        (4.8)式           *[RQ.8]
gqcal(yosokbuB)  #15日以後に陰性になる確率      (4.14)式,(4.15)式 *[RQ.11]

#生成量の推定結果(分布の要約) 新薬A
gqcal(sa15 )     #基準点15日と平均値の差        (4.8)式
gqcal(yosokbu)   #15日以後に陰性になる確率      (4.14)式,(4.15)式

#自習2 ######不偏分散の不偏性##########################################

#状況の設定
試行数<-1000000;
n <-5;
母平均<-0
母分散<-1
標本分散<-不偏分散<-平均<-numeric(試行数);
for (i in (1:試行数)){
  data<-rnorm(n, 母平均,sqrt(母分散))
  平均[i] <-mean(data)
  標本分散[i]<-mean((data - 平均[i])^2)
  不偏分散[i]<- sum((data - 平均[i])^2) / (n-1)
  }
hist(平均,breaks=100)
mean(平均)
hist(標本分散,breaks=100)
mean(標本分散)
hist(不偏分散,breaks=100)
mean(不偏分散)

自習3  ######t検定をする###################################################
t.test(x, mu = 15.0);
t.test(xB, mu = 15.0)

#新薬Aのp値は	0.00002188
#新薬Bのｐ値は	0.0000009352  であることを確認せよ。
# 1) この値は基準となる0.05より、遥かに小さい。遥かに小さいという事実から、
#この２つの新薬ＡＢの効き目が極めて高いと結論できるか？　
# 2) また新薬Ｂのp値が、新薬Ａより小さい。
#このことから新薬Ｂのほうがすぐれた薬であると結論してよいか？


