#######################################################################
#第5章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表1.1 測定結果(日数) 抗原検査データ
x<-c(
11.5, 14.0, 15.0, 10.0, 14.0, 14.5, 12.5, 12.5, 12.5, 12.0, 
13.0, 12.0, 12.5, 13.5, 15.0, 13.5, 12.5, 12.0, 12.0, 17.0)

#正規分布に関する推測
out0301 <-G1mean(x,prior=F)
#save(out0301,  file="./scrJ/obje/out0301")
#load(file="./scrJ/obje/out0301"); #予めMCMCした結果をロード

#図5.1　μ<=13.5という事象に付与された確率を示す面積
hist(out0301$mu[out0301$mu<13.5] ,breaks=70,col=gray(0.6),xlim=c(11,15),
   ylim=c(0,5500),cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="") 
par(new=T)
hist(out0301$mu[out0301$mu>=13.5],breaks=30,col=gray(1.0),xlim=c(11,15),
   ylim=c(0,5500),cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="") 
#dev.copy2eps(file="z0501mu.eps",family="Japan1")

#5.1.4 研究仮説μ＜13.5 が成立する確率  (5.2)式,(5.3)式,(5.4)式の例示
temp01<-out0301$mu[11:20]
round(temp01,2)
ifelse(temp01<13.5,1,0)

#関数 phc01(　)はphc曲線を描画する。またはphcテーブルを作成する。
# seq01: 基準点 c (曲線の横軸)を表現した等差数列(またはスカラー)
# a    : 数値ベクトル、母数または生成量または予測分布の乱数
# b    : スカラーor数値ベクトル、母数or生成量or予測分布の乱数、規定値は0
# cc   : "gtc"は a - b >c 、"rope"は abs(a-b)<c 、"ltc"は a - b <c
#        bの規定値は0だから、指定しなければ、ccはaに対する指示となる。
# byoga: "yes"はphc曲線の描画、"no"はphcテーブルを作成
#dedits: 整数、出力される小数点以下の桁数

#5.2 「研究仮説が正しい確率」PHC  (5.6)式
phc01(13.5, out0301$mu,0, cc="ltc", byoga="no")

#5.2.3 「事実上同じ範囲」ROPE     (5.7)式,(5.8)式,(5.9)式
phc01(1.5, out0301$mu ,15.0, cc="rope", byoga="no")

#「むしろはっきり長い」という仮説が正しい確率 p.67 一番下の式
phc01(16.5, out0301$mu, 0, cc="gtc", byoga="no", dedits=5)

#5.3.3 基準点c は必ずしも事前に決めなくてもよい
#表5.1 phc(μ<=c)のphcテーブル (新薬A)
phc01(seq(11.5,15.0,0.5), out0301$mu, 0, cc="ltc", byoga="no")

#図5.2 phc(μ<=c)のphc 曲線(新薬A) n=20
phc01(seq(11,16,0.2),out0301$mu,0,cc="ltc",byoga="yes",cex.lab=2.2,cex.axis=2.0)
text(14.25,0.8,"★",cex=4.0)
#dev.copy2eps(file="z05phc_mu.eps",family="Japan1")

#5.3.4 n が小さいと，分析者に有利な主張は支持されにくい
#抗原検査Bの母数の事後分布
xB<-scan("scrJ/抗原検査B.dat",sep="")

out0303 <-G1mean(xB,prior=F)#正規分布に関する推測
#save(out0303,  file="./scrJ/obje/out0303")
#load(file="./scrJ/obje/out0303"); #予めMCMCした結果をロード

#図5.3 phc(μ<=c)のphc 曲線(新薬B) n=1000
phc01(seq(11,16,0.02),out0303$mu,cc="ltc",byoga="yes",cex.lab=2.2,cex.axis=2.0)
arrows(14.25,0.8,14.25,0.1,lwd=7.0)
arrows(15.25,0.2,15.25,0.9,lwd=7.0)
#dev.copy2eps(file="z05phc_muB.eps",family="Japan1")

#表5.2 phc(c<=c)のphc テーブル(新薬B)
phc01(seq(14.5,15.2,0.1), out0303$mu ,0,cc="ltc", byoga="no");

#5.3.7 ROPE のphc 曲線
#表5.3 phc(|μ-15,|< c) のphcテーブル  (ROPEの評価)
phc01(seq(0,4.0,0.5), out0301$mu ,15.0,cc="rope", byoga="no");

#図5.4 phc(|μ-15,|< c) のphc曲線
phc01(seq(0,4,0.1),out0301$mu,15,cc="rope",byoga="yes",cex.lab=2.2,cex.axis=2)
#dev.copy2eps(file="z05ROPE_mu.eps",family="Japan1")

#5.4 生成量のphc 曲線
#表5.4 母数と生成量のphcテーブル
sa15<-15-out0301$mu                       #基準点15日と平均値の差      (4.8)式
delta15<-(out0301$mu-15.0)/out0301$sigma; #デルタδ                   (4.10)式
hirit15mu<-out0301$mu/15                #15日に対する平均の比 (4.16)式,(4.17)式
phc01(seq(1,3,0.25),         out0301$sigma ,   0,cc="ltc",byoga="no");
phc01(round(seq(2/3,10/3,1/3),3),sa15,0,cc="gtc",byoga="no");
phc01(seq(-2.0,0.0,0.25),        delta15,  0,cc="ltc",byoga="no");
phc01(seq(0.8,1.0,0.025),        hirit15mu,0,cc="ltc",byoga="no");

#図5.5 母数と生成量のphc曲線
par(mfrow=c(4,1))
phc01(seq(1,3,0.1),out0301$sigma,0,cc="ltc",byoga="yes",cex.lab=2.5,
        cex.axis=2.0,xlab="a. 標準偏差");                            #sd
phc01(seq(2/3,10/3,1/30),sa15,0,cc="gtc",byoga="yes",cex.lab=2.5,
        cex.axis=2.0,xlab="b. 基準点と平均値との差");                #sa15
phc01(seq(-2.0,0.0,0.05),delta15,0,cc="ltc",byoga="yes",cex.lab=2.5,
        cex.axis=2.0, xlab="c. 標準化された基準点と平均値との差");   #delta15
phc01(seq(0.8,1.0,0.005),hirit15mu,0,cc="ltc",byoga="yes",cex.lab=2.5,
        cex.axis=2.0,xlab="d. 基準点と平均値との比");                #hirit15mu
par(mfrow=c(1,1))
#dev.copy2eps(file="z05other_phc.eps",family="Japan1")

########################################################################
#第5章 5.6 実習課題 p.75
#表1.3 測定結果(秒) (「知覚時間」のデータ入力)
y<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)

out0302 <-G1mean(y,prior=F)#正規分布に関する推測
#save(out0302,  file="./scrJ/obje/out0302")
#load(file="./scrJ/obje/out0302"); #予めMCMCした結果をロード

#例示スクリプトは省略

########################################################################
#第5章 5.7 実践問題 p.75

xB<-scan("scrJ/抗原検査B.dat",sep="")

out0303 <-G1mean(xB,prior=F)#正規分布に関する推測
#save(out0303,  file="./scrJ/obje/out0303")
#load(file="./scrJ/obje/out0303"); #予めMCMCした結果をロード

#教科書の実践問題のためのスクリプトは割愛
#以下の自習に応えるための結果は教科書にあるので、新たな計算の必要はない。


########################################################################

#自習
# 1)表5.1と表5.2からどのようなことが言えるか。phc曲線の観点からは
#    あなたは新薬A,Bどちらの薬が有用であると考えるか？
# 2)mu=15.0 の有意性検定では
#     新薬A：p値=0.00002188
#     新薬B：p値=0.0000009352
#  で明らかに新薬Bの方が小さい。このことは 1) とどう整合するのか
