#####################################################################
#第7章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表6.1 実験群と対照群の英語の成績
#実験群
x1<-c(49,66,69,55,54,72,51,76,40,62,66,51,59,68,66,57,53,66,58,57)
#対照群
x2<-c(41,55,21,49,53,50,52,67,54,69,57,48,31,52,56,50,46,38,62,59)
print(x1);print(x2)

#MCMCの実行
out0601<-G2Ind(x1,x2,EQU=0,prior=F)
#save(out0601,  file="./scrJ/obje/out0601")
#load(file="./scrJ/obje/out0601"); #予めMCMCした結果をロード

gqcal(out0601$ext[,1:6])

#MCMC標本の名前が長いので取り出す。
mu1   <-out0601$mu1;   mu2   <-out0601$mu2;
sigma1<-out0601$sigma1;sigma2<-out0601$sigma2;
xaste1<-out0601$xaste1;xaste2<-out0601$xaste2;
dmu   <-mu1-mu2;  
dsigma<-sigma1-sigma2; 

#7.1.1 群内標準偏差
sigma_within <-sqrt((sigma1^2 + sigma2^2)/2);  #(7.1)式

#表7.1　標準化された平均値差の事後分布の数値要約
delta   <-dmu/sigma_within;        #(7.2)式、標準化された平均値差
delta1  <-dmu/sigma1;              #(7.3)式
delta2  <-dmu/sigma2;              #(7.3)式
gqcal(cbind(sigma_within,delta,delta1,delta2))


#図7.3 群内標準偏差の事後分布　デルタの事後分布の位置関係の確認
par(mfrow=c(1,2))
#左図
hist(sigma_within ,breaks=100,col=gray(1.0),cex.axis=2.0,cex.lab=2.0,
      main="",xlab="群内標準偏差",ylab="") 
#右図
plot(density(delta),xlim=c(-1,3),ylim=c(0,1.3),cex.axis=2.0,cex.lab=2.0,
         main="",xlab="",ylab="",lwd=2.0) 
par(new=T)
plot(density(delta1),xlim=c(-1,3),ylim=c(0,1.3),cex.axis=2.0,cex.lab=2.0,
         main="",xlab="",ylab="",lwd=2.0) 
par(new=T)
plot(density(delta2),xlim=c(-1,3),ylim=c(0,1.3),cex.axis=2.0,cex.lab=2.0,
         main="",xlab="標準化された平均値差",ylab="",lwd=2.0) 
   text(0.2,1.0,"δ2" ,cex=2.0)
   text(1.25,1.1,"δ",cex=2.0)
   text(1.9,0.3,"δ1" ,cex=2.0)
par(mfrow=c(1,1))
#dev.copy2eps(file="z0703kk.eps",family="Japan1")


#7.1.8 phc による考察
#表7.2　標準化された平均値差のphc テーブル
phc01(seq(0.0,0.5,0.1),delta, 0,cc="gtc", byoga="no"); #(7.2)式
phc01(seq(0.0,0.5,0.1),delta1,0,cc="gtc", byoga="no"); #(7.3)式
phc01(seq(0.0,0.5,0.1),delta2,0,cc="gtc", byoga="no"); #(7.3)式
#ROPE
phc01(seq(0.0,0.5,0.1),delta, 0,cc="rope", byoga="no");#
phc01(seq(0.0,0.5,0.1),delta1,0,cc="rope", byoga="no");#
phc01(seq(0.0,0.5,0.1),delta2,0,cc="rope", byoga="no");#


#図7.4　標準化された平均値差のphc 曲線
par(mfrow=c(2,1))
phc01(seq(0.0,2.5,0.1),delta ,0,cc="gtc", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,2.5,0.1),delta1,0,cc="gtc", byoga="yes",lwd=2.0,lty=3);par(new=T)
phc01(seq(0.0,2.5,0.1),delta2,0,cc="gtc", byoga="yes",lwd=2.0,lty=3);
text(1.2,0.5,"δ1" ,cex=2.0)
text(0.6,0.5,"δ2" ,cex=2.0)
#ROPE
phc01(seq(0.0,2.5,0.1),delta ,0,cc="rope",byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,2.5,0.1),delta1,0,cc="rope",byoga="yes",lwd=2.0,lty=3);par(new=T)
phc01(seq(0.0,2.5,0.1),delta2,0,cc="rope",byoga="yes",lwd=2.0,lty=3);
text(1.2,0.5,"δ1" ,cex=2.0)
text(0.6,0.5,"δ2" ,cex=2.0)
par(mfrow=c(1,1))
#dev.copy2eps(file="z0704kk.eps",family="Japan1")


#表7.3 非重複度の事後分布の推定結果
U1   <-pnorm(mu1,mu2,sigma_within); #(7.6)式,非重複度,分母は群内標準偏差
U2   <-pnorm(mu2,mu1,sigma_within); #(7.7)式,非重複度,分母は群内標準偏差
U1a  <-pnorm(mu1,mu2,sigma2);       #(7.9)式,非重複度,分母は第2群標準偏差
U2a  <-pnorm(mu2,mu1,sigma1);       #(7.10)式,非重複度,分母は第1群標準偏差
gqcal(cbind(U1,U2,U1a,U2a))


#図7.7 非重複度の事後分布の位置関係の比較
plot(density(U1),xlim=c(0,1),ylim=c(0,5),
      cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="",lwd=2.0);par(new=T)
plot(density(U1a),xlim=c(0,1),ylim=c(0,5),
      cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="",lwd=2.0);par(new=T)
plot(density(U2),xlim=c(0,1),ylim=c(0,5),
      cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="",lwd=2.0);par(new=T)
plot(density(U2a),xlim=c(0,1),ylim=c(0,5),
      cex.axis=2.0,cex.lab=2.0,main="",xlab="",ylab="",lwd=2.0) 
   text(0.92,3.5,"U1"  ,cex=2.0)
   text(0.68,3.5,"U1*" ,cex=2.0)
   text(0.3 ,3.5,"U2"  ,cex=2.0)
   text(0.03,3.5,"U2*" ,cex=2.0)
#dev.copy2eps(file="z0707kk.eps",family="Japan1")


#表7.4　非重複度のphc テーブル／事実上0.5 であるROPE のphc テーブル
phc01(seq(0.5,0.75,0.05),U1  ,0,cc="gtc", byoga="no");#
phc01(seq(0.5,0.75,0.05),U1a ,0,cc="gtc", byoga="no");#
phc01(seq(0.25,0.5,0.05),U2  ,0,cc="ltc", byoga="no");#
phc01(seq(0.25,0.5,0.05),U2a ,0,cc="ltc", byoga="no");#
#ROPE
phc01(seq(0.0,0.25,0.05),U1  ,0.5,cc="rope", byoga="no");#
phc01(seq(0.0,0.25,0.05),U1a ,0.5,cc="rope", byoga="no");#
phc01(seq(0.0,0.25,0.05),U2  ,0.5,cc="rope", byoga="no");#
phc01(seq(0.0,0.25,0.05),U2a ,0.5,cc="rope", byoga="no");#


#図7.8　非重複度のphc 曲線／事実上0.5 であるROPE のphc 曲線
par(mfrow=c(3,1))
#上段
phc01(seq(0.5,1.0,0.01),U1 ,0,cc="gtc", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.5,1.0,0.01),U1a ,0,cc="gtc", byoga="yes",lwd=2.0);
text(0.85,0.6,"U1"  ,cex=2.0)
text(0.70,0.6,"U1*" ,cex=2.0)
#中段
phc01(seq(0.0,0.5,0.01),U2 ,0,cc="ltc", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,0.5,0.01),U2a ,0,cc="ltc", byoga="yes",lwd=2.0);
text(0.3 ,0.6,"U2"  ,cex=2.0)
text(0.1 ,0.6,"U2*" ,cex=2.0)
#下段
phc01(seq(0.0,0.5,0.01),U1 ,0.5,cc="rope", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,0.5,0.01),U2 ,0.5,cc="rope", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,0.5,0.01),U1a,0.5,cc="rope", byoga="yes",lwd=2.0);par(new=T)
phc01(seq(0.0,0.5,0.01),U2a,0.5,cc="rope", byoga="yes",lwd=2.0);
text(0.33,0.6,"U1 U2"  ,cex=2.0)
text(0.20,0.6,"U1*" ,cex=2.0)
text(0.45,0.6,"U2*" ,cex=2.0)
par(mfrow=c(1,1))
#dev.copy2eps(file="z0708kk.eps",family="Japan1")


#図7.9 閾上率の視覚化
nob<-1000
plot(xaste1[1:nob],xaste2[1:nob],xlim=c(0,100),ylim=c(0,100),cex.axis=2.0,
         cex.lab=1.3,main="",xlab="実験群",ylab="対照群",lwd=2.0) 
   abline( 0 ,1,lwd=2,lty=1)
   abline(-3 ,1,lwd=2,lty=2)
   abline(-5 ,1,lwd=2,lty=3)
   abline(-10,1,lwd=2,lty=4)
   arrows(25,25,35,10,lwd=4)
   text(39,6,"72％",cex=4)
#dev.copy2eps(file="z0709kk.eps",family="Japan1")


# ikijyori2(　)閾上率の曲線・テーブルを返す関数
#seq01: 基準点 c のベクトル(またはスカラー)
#out  : mu1,mu2,sigma1,sigma2 の乱数ベクトルを含むMCMCオブジェクト
#byoga="yes"の場合は閾上率の曲線、それ以外の場合は閾上率のテーブルを出力

#表7.5 閾上率の事後分布の数値要約
ikijyori2(c(0,3,5,10),out0601,byoga="no")

#図7.10 閾上率のEAPと両側95％確信区間上限・下限
ikijyori2(seq(-10,30,1),out0601,byoga="yes")
#dev.copy2eps(file="z0710kk.eps",family="Japan1")


#付録:「成績の差が3点を超える確率が0.7より大きい」という判断が正しい確率
ikijyo3<-pnorm((mu1-mu2-3)/sqrt(sigma1^2+sigma2^2),0,1)
phc01(0.7,ikijyo3,0,cc="gtc", byoga="no");     #


########################################################################
#第7章実習課題

#表6.8 聴音条件の知覚時間の測定結果(秒)
#聴音条件のデータ入力
y1<-c(32.30,34.24,28.10,33.40,37.71,31.62,31.37,35.85,32.33,34.04,
     34.96,31.43,35.28,30.19,35.09,33.38,31.49,28.44,32.12,31.81)

#対照条件のデータ入力
y2<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)

out0602<-G2Ind(y1,y2,EQU=0,prior=F)
#save(out0602,  file="./scrJ/obje/out0602")
#load(file="./scrJ/obje/out0602"); #予めMCMCした結果をロード
gqcal(out0602$ext[,1:6])

#その他のスクリプト例は割愛する

########################################################################

#自習 副読本 p.26, p.92  以下の図・表番号は副読本による
#　新しく発売された抗菌薬A の肺炎に対する治療効果を調べるために，
#新たに入院する肺炎患者を対象として，抗菌薬A を投与した群(A 群) と
#既存の抗菌薬B を投与した群(B 群) とに割り付けて，
#治療効果を入院期間で比較検討した。以下基準は対照群で計算せよ。
#1)標準化平均値差の事後分布、phcテーブル、phc曲線を解釈せよ。
#2)非重複度の事後分布、phcテーブル、phc曲線を解釈せよ。
#3)閾上率の事後分布、phcテーブル、phc曲線を解釈せよ。

#表6-1　抗菌薬Aの治療効果の生データ
実験群<-c(5.5,10.0,5.5,6.0,9.0,9.5,6.5,7.0,12.5,7.0,6.5,10.5,
                 9.0,4.5,6.5,9.5,10.0,9.5,10.5,6.5,8.5,12.5,4.0,9.0)
対照群<-c(5.5,11.5,7.0,7.5,10.5,11.0,8.0,8.5,14.0,8.5,10.0,8.0,12.0,
                 10.5,6.0,8.0,11.0,11.5,11.0,12.0,8.0,10.0,14.0,5.5,10.5,9.0)

#EAP推定値、確信区間
out0603<-G2Ind(対照群,実験群,EQU=0,prior=T,mL=0, mH=100, sL=0, sH=100)
#save(out0603,  file="./scrJ/obje/out0603")
#load(file="./scrJ/obje/out0603"); #予めMCMCした結果をロード

#1)標準化平均値差の事後分布、phcテーブル、phc曲線を解釈せよ。
delta_con<-(out0603$mu1-out0603$mu2)/out0603$sigma1; 
phc01(seq(-0.5,2.0,0.05),delta_con,0,cc="gtc",byoga="yes");#図6-4
phc01(seq( 0.0,0.4,0.05),delta_con,0,cc="gtc",byoga= "no");#表6-4

(9.6-8.1)/2.3;                  #標本平均・標本標準偏差による効果量

#2)非重複度の事後分布、phcテーブル、phc曲線を解釈せよ。
U1a<-pnorm(out0603$mu1,out0603$mu2,out0603$sigma2);         #非重複度の事後分布
phc01(seq(0.4,1.0,0.05),U1a,0,cc="gtc", byoga="yes");       #図6-6
phc01(seq(0.5,0.6,0.01),U1a,0,cc="gtc", byoga="no");        #表6-5


#3)閾上率の事後分布、phcテーブル、phc曲線を解釈せよ。
#表6.6 閾上率の事後分布の数値要約
ikijyori2(seq(0,2.5,0.25),out0603,byoga="no",dedits=2)
#図6.7 閾上率のEAPと両側95％確信区間上限・下限
ikijyori2(seq(0,2.5,0.25),out0603,byoga="yes")



