####################################################################
#第8章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表8.1 心の健康得点の半年間の変化
#援助後：
x1<-c(73,72,56,58,71,42,78,77,75,72,56,71,69,77,84,51,62,88,56,58,84,91,71,82,
81,77,65,78,79,60,66,70,65,57,64,61,56,67,75,64,68,67,80,55,48,85,56,62,65,79)
#援助前：
x2<-c(62,54,19,54,47,22,35,77,64,60,27,41,41,44,57,16,42,89,40,67,69,46,74,62,
60,87,32,42,73,25,42,57,31,35,33,38,43,53,55,62,67,56,76,05,31,70,66,65,34,48)
print(x1);print(x2)     #(8.1)式,(8.2)式

#表8.2 「心の健康」データの数値要約
n<-length(x1)                           #データ数
h1<-mean(x1);round(h1,1)                #平均値
h2<-mean(x2);round(h2,1)
va1<-van(x1);round(va1,1)               #分散
va2<-van(x2);round(va2,1)
sd1<-sqrt(va1);round(sd1,2)             #標準偏差
sd2<-sqrt(va2);round(sd2,2)
(me1<-median(x1))                       #中央値
(me2<-median(x2))
round(quantile(x1,type =2),1)           #％点
round(quantile(x2,type =2),1)

#図8.1 「心の健康」データの箱ひげ図
x<-c(x1,x2);y<-c(rep("援助後群",n),rep("援助前群",n))
boxplot(x~y,cex.axis=2.0,xlab="",ylab="")                 
#dev.copy2eps(file="z04boxplot.eps",family="Japan1")

#図8.2 「心の健康」データの散布図
plot(x2,x1,cex.axis=2.0,cex.lab=1.0,main="",xlab="援助前",ylab="援助後",lwd=2)
abline(0,1,lwd=1.5)         
#dev.copy2eps(file="z04sanpu.eps",family="Japan1")

#表8.3 「心の健康」データの平均偏差データ
v1<-x1-h1;round(v1,1)     #(8.3)式
v2<-x2-h2;round(v2,1)     #(8.4)式

#共分散  (8.5)式,(8.6)式
Co<-mean(v1*v2);round(Co,1)

#図8.3 平均偏差データの散布図
plot(v2,v1,cex.axis=2.0,cex.lab=1.0,main="",xlab="援助前",ylab="援助後",lwd=2)
abline(h=0,lwd=1.5);abline(v=0,lwd=1.5)         #
text(-40,-25,"+",cex=3.5)
text( 35, 20,"+",cex=3.5)
text(-40, 20,"-",cex=3.5)
text( 35,-25,"-",cex=3.5)
#dev.copy2eps(file="z04vz_sanpu.eps",family="Japan1")

#表8.4　「心の健康」データの標準化データ
z1<-v1/sd1;round(z1,2)     #(8.7)式
z2<-v2/sd2;round(z2,2)     #(8.8)式

#相関係数  (8.9)式,(8.10)式
r<-mean(z1*z2);round(r,2)

#8.2     2変量正規分布
#対応ある2群の差の推測
x<-cbind(x1,x2)
out0801<-G2pair(x,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0801,  file="./scrJ/obje/out0801")
#load(file="./scrJ/obje/out0801"); #予めMCMCした結果をロード

#表8.5 母数の事後分布と予測分布の数値要約
gqcal(out0801$ext[,1:7])


#乱数の取り出し
mu1<-out0801$mu1;mu2<-out0801$mu2;
sigma1<-out0801$sigma1;sigma2<-out0801$sigma2;
xaste1<-out0801$xaste1;xaste2<-out0801$xaste2;
rho<-out0801$rho

# 生成量の構成
dmu     <-mu1-mu2;                          #平均値の差
dsigma  <-sigma1-sigma2;                    #標準偏差の差
sigma_within <-sqrt((sigma1^2 + sigma2^2)/2)#(7.1)式、群内標準偏差
delta   <-dmu/sigma_within;                 #(7.2)式、標準化された平均値差
delta1  <-dmu/sigma1;                       #(7.3)式
delta2  <-dmu/sigma2;                       #(7.4)式
U1      <-pnorm(mu1,mu2,sigma_within);  #(7.6)式,非重複度,分母は群内標準偏差
U2      <-pnorm(mu2,mu1,sigma_within);  #(7.7)式,非重複度,分母は群内標準偏差
U1a     <-pnorm(mu1,mu2,sigma2);        #(7.9)式,非重複度,分母は第2群標準偏差
U2a     <-pnorm(mu2,mu1,sigma1);        #(7.10)式,非重複度,分母は第1群標準偏差

#表8.6 生成量の事後分布の数値要約
gqcal(cbind(dmu,dsigma,sigma_within,delta,delta1,delta2,U1,U2,U1a,U2a))

#図8.7 phc曲線
par(mfrow=c(4,1))
phc01(seq(10,25,0.5),     dmu,   0,cc="gtc",byoga="yes",xlab="平均値差 dμ");#
phc01(seq(0.5,1.3,0.05),  delta2,0,cc="gtc",byoga="yes",
      xlab="標準化された平均値差δ2");#
phc01(seq(0.65,0.95,0.02),U1a   ,0,cc="gtc",byoga="yes",xlab="非重複度 U1*");#
ikijyori2(seq(0,30,5),    out0801,byoga="yes");#
par(mfrow=c(1,1))
#dev.copy2eps(file="z0807kk.eps",family="Japan1")

#表8.7 phcテーブル
phc01(seq(5,30,5),     dmu,   0,cc="gtc",byoga="no");  #平均値差
phc01(seq(0.6,1.1,0.1),  delta2,0,cc="gtc",byoga="no");#標準化された平均値差
phc01(seq(0.7,0.95,0.05),U1a   ,0,cc="gtc",byoga="no");#非重複度
ikijyori2(seq(5,30,5),    out0801,byoga="no");         #閾上率

########################################################################
#第8章 8.5 実習課題 p.119

#表8.8の長さの目測と実測の生データ(mm)
y1<- c(110,232,176,207,122,202,191,124,193,250); #目測群
y2<- c(130,268,104,185,128,147,162, 68,142,175); #実測群
y<-cbind(y1,y2)

out0802<-G2pair(y,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0802,  file="./scrJ/obje/out0802")
#load(file="./scrJ/obje/out0802"); #予めMCMCした結果をロード

#以降のスクリプト例は割愛する


########################################################################
#自習
#あるダイエット法の効果を調べるために，20 名の女性に参加してもらいました．
#プログラム参加前体重と，参加後体重が以下である。このダイエット法は有効か．
#x1がbeforeであり、x2がafterである。等分散を仮定して以下に回答しなさい。
#1) 平均値の差に関する事後分布とphcを考察しなさい。
#2) 標準化された平均値差に関する事後分布とphcを考察をしなさい。
#3) 非重複度に関する事後分布とphcを考察をしなさい。
#4) 閾上率を解釈しなさい。

w1<-c(53.1,51.5,45.5,55.5,49.6,50.1,59.2,54.7,53.0,48.6,
      55.3,52.6,51.7,48.6,56.4,42.9,50.3,42.4,51.2,39.1)
w2<-c(48.3,45.2,46.6,56.6,41.2,44.6,51.9,55.5,45.4,47.6,
      50.6,54.5,49.0,43.9,53.8,40.1,52.8,35.3,55.6,38.0)

w<-cbind(w1,w2)
out0803<-G2pair(w,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0803,  file="./scrJ/obje/out0803")
#load(file="./scrJ/obje/out0803"); #予めMCMCした結果をロード

#表8.5 母数の事後分布と予測分布の数値要約
gqcal(out0803$ext[,1:7])

#乱数の取り出し
mu1<-out0803$mu1;mu2<-out0803$mu2;
sigma1<-out0803$sigma1;sigma2<-out0803$sigma2;
xaste1<-out0803$xaste1;xaste2<-out0803$xaste2;
rho<-out0803$rho

#生成量の事後分布
dmu     <-mu1-mu2;                          #平均値の差
sigma_within <-sqrt((sigma1^2 + sigma2^2)/2)#(7.1)式、群内標準偏差
delta   <-dmu/sigma_within;                 #(7.2)式、標準化された平均値差
U2      <-pnorm(mu2,mu1,sigma_within);  #(7.7)式,非重複度,分母は群内標準偏差

# 1)
gqcal(dmu   )
phc01(seq(0.5,5.0,0.5),dmu, 0,cc="gtc",byoga="yes"); #平均値差
phc01(seq(0.5,5.0,0.5),dmu, 0,cc="gtc",byoga="no");  #平均値差

# 2)
gqcal(delta )
phc01(seq(0.0,1.0,0.1),delta,0,cc="gtc",byoga="yes");#標準化された平均値差
phc01(seq(0.0,1.0,0.2),delta,0,cc="gtc",byoga="no"); #標準化された平均値差

# 3)
gqcal(U2    )
phc01(seq(0.1,0.6,0.02),U2,0,cc="ltc",byoga="yes");#非重複度
phc01(seq(0.1,0.6,0.05),U2,0,cc="ltc",byoga="no" );#非重複度

# 4)
ikijyori2(seq(0,3,0.2),    out0803,byoga="yes");    #閾上率曲線
ikijyori2(seq(0,3,0.5),    out0803,byoga="no");     #閾上率テーブル
