#######################################################################
#第9章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表8.1 心の健康得点の半年間の変化
#援助後：
x1<-c(73,72,56,58,71,42,78,77,75,72,56,71,69,77,84,51,62,88,56,58,84,91,71,82,
81,77,65,78,79,60,66,70,65,57,64,61,56,67,75,64,68,67,80,55,48,85,56,62,65,79)
#援助前：
x2<-c(62,54,19,54,47,22,35,77,64,60,27,41,41,44,57,16,42,89,40,67,69,46,74,62,
60,87,32,42,73,25,42,57,31,35,33,38,43,53,55,62,67,56,76,05,31,70,66,65,34,48)
print(x1);print(x2)     #(8.1)式,(8.2)式

#対応ある2群の差の推測
x<-cbind(x1,x2)
out0801<-G2pair(x,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0801,  file="./scrJ/obje/out0801")
#load(file="./scrJ/obje/out0801"); #予めMCMCした結果をロード

#表8.5 母数の事後分布の数値要約(前章復習)
gqcal(out0801$ext[,1:7])

#乱数の取り出し
mu1<-out0801$mu1;mu2<-out0801$mu2;                #平均値
sigma1<-out0801$sigma1;sigma2<-out0801$sigma2;    #標準偏差
xaste1<-out0801$xaste1;xaste2<-out0801$xaste2;    #予測分布
rho<-out0801$rho;                                 #相関係数
dmu     <-mu1-mu2;                                #平均値の差
dsigma  <-sigma1-sigma2;                          #標準偏差の差

#差得点の事後予測分布     (9.1)式
ds<-xaste1-xaste2
gqcal(ds)

#差得点の平均の事後分布   (9.2)式
gqcal(dmu);

#差得点の標準偏差の生成量 (9.3)式
sigmaD  <-sqrt(sigma1^2+sigma2^2-2*rho*sigma1*sigma2);

#図9.1 差得点の事後予測分布 と 差得点の標準偏差の事後分布
par(mfrow=c(1,2))
#左図
hist(ds ,breaks=100,col=gray(1.0),cex.axis=2.0,cex.lab=2.0,
      main="",xlab="差得点の事後予測分布",ylab="") 
      arrows(18.6,5000,18.6,0,lwd=2)
      text(22.0,5150,"平均 18.6点",cex=2)
      arrows(18.6,1500,18.6-15.6,1500,lwd=4,lty=1)
      text(60,1500,"差得点のSD 15.7",cex=2)
      arrows(0,1000,18.6,1000,lwd=4,lty=1)
      text(-25,1000,"援助の効果",cex=2)
#右図
hist(sigmaD, breaks=100,col=gray(1.0),cex.axis=2.0,cex.lab=2.0,
      main="",xlab="差得点の標準偏差の事後分布",ylab="")
par(mfrow=c(1,1))
#dev.copy2eps(file="z0802.eps",family="Japan1")

#表9.1 差得点の標準偏差の事後分布の数値要約とphcテーブル
gqcal(sigmaD,1)
phc01(seq(15,21,1),sigmaD,cc="ltc",byoga="no")

#図9.2 差得点の標準偏差のphc 曲線
phc01(seq(10,24,0.2),sigmaD,cc="ltc",byoga="yes",xlab="差得点の標準偏差")
#dev.copy2eps(file="z0802tt.eps",family="Japan1")

#表9.2 標準化された差得点の平均
deltaD  <-dmu/sigmaD;                 #(9.9)式、(9.10)式
gqcal(deltaD)
phc01(seq(0.6,1.2,0.1),deltaD,cc="gtc",byoga="no")

#図9.3 標準化された差得点の平均の事後分布とphc曲線
par(mfrow=c(1,2))
#左図
hist(deltaD, breaks=100,col=gray(1.0),cex.axis=2.0,cex.lab=2.0,main="",
      xlab="標準化された差得点の平均の事後分布",ylab="")
#右図
phc01(seq(0.5,2.0,0.05),deltaD,cc="gtc",byoga="yes",
      xlab="標準化された差得点の平均")
par(mfrow=c(1,1))
#dev.copy2eps(file="z0802jk.eps",family="Japan1")


#図9.4 差得点の閾上率の視覚化
nob<-1000
plot(xaste1[1:nob],xaste2[1:nob],xlim=c(0,100),ylim=c(0,100),cex.axis=2.0,
      cex.lab=1.3,main="",xlab="援助後",ylab="援助前",lwd=2.0) 
      abline( 0 ,1,lwd=2,lty=1)
      abline(-3 ,1,lwd=2,lty=2)
      abline(-5 ,1,lwd=2,lty=3)
      abline(-10,1,lwd=2,lty=4)
      arrows(25,25,35,10,lwd=4)
      text(39,6,"88.5％",cex=2.5)
#dev.copy2eps(file="z0909kw.eps",family="Japan1")

#9.3.4 閾上率と差得点の閾上率の関係に登場する「閾上率」
ikijyori2(c(0,3,5,10),out0801,byoga="no")

#表9.3  差得点の閾上率の事後分布の推定結果
Dikijyori2(c(0,3,5,10),out0801,byoga="no")

#図9.5 閾上率のEAP と両側95%確信区間上限・下限
Dikijyori2(seq(-10,30,2),out0801,byoga="yes")
#dev.copy2eps(file="z0910kk.eps",family="Japan1")

########################################################################
#第9章 9.7 実習課題 p.135

#表8.8の長さの目測と実測の生データ(mm)
y1<- c(110,232,176,207,122,202,191,124,193,250); #目測群
y2<- c(130,268,104,185,128,147,162, 68,142,175); #実測群

y<-cbind(y1,y2)
out0802<-G2pair(y,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0802,  file="./scrJ/obje/out0802")
#load(file="./scrJ/obje/out0802"); #予めMCMCした結果をロード

#以降のスクリプト例は割愛する


########################################################################
#付録「援助後のほうが10点高くなる確率は60％より大きい」という判断が正しい確率
Dikijyo10<-pnorm((mu1-mu2-10)/sqrt(sigma1^2+sigma2^2-2*rho*sigma1*sigma2),0,1)
phc01(0.6,Dikijyo10,0,cc="gtc",byoga="no")



########################################################################
#自習
#あるダイエット法の効果を調べるために，20 名の女性に参加してもらいました．
#プログラム参加前体重と，参加後体重が以下である。このダイエット法は有効か．
#x1がbeforeであり、x2がafterである。等分散を仮定して以下に回答しなさい。
#1) 標準化された平均値差、差得点の平均の事後分布とphcを比較・考察せよ。
#2) 閾上率と差得点の閾上率を比較・考察をしなさい。
#3) 対応ある2群の平均値差の検定をしなさい。

w1<-c(53.1,51.5,45.5,55.5,49.6,50.1,59.2,54.7,53.0,48.6,
      55.3,52.6,51.7,48.6,56.4,42.9,50.3,42.4,51.2,39.1)
w2<-c(48.3,45.2,46.6,56.6,41.2,44.6,51.9,55.5,45.4,47.6,
      50.6,54.5,49.0,43.9,53.8,40.1,52.8,35.3,55.6,38.0)

w<-cbind(w1,w2)
out0803<-G2pair(w,EQU=0,prior=T,mL=0, mH=250, sL=0, sH=125)
#save(out0803,  file="./scrJ/obje/out0803")
#load(file="./scrJ/obje/out0803"); #予めMCMCした結果をロード

gqcal(out0803$ext[,1:7])

#乱数の取り出し、生成量の作成
dmu     <-out0803$mu1-out0803$mu2;             #平均値の差
sigma1<-out0803$sigma1;sigma2<-out0803$sigma2; #標準偏差
rho<-out0803$rho;                              #相関係数
sigma_within <-sqrt((sigma1^2 + sigma2^2)/2)   #(7.1)式、群内標準偏差
sigmaD  <-sqrt(sigma1^2+sigma2^2-2*rho*sigma1*sigma2);#差得点の標準偏差(9.3)式
delta   <-dmu/sigma_within;                    #(7.2)式、標準化された平均値差
deltaD  <-dmu/sigmaD;                          #(9.9)式、(9.10)式

#1) 標準化された平均値差、差得点の平均の事後分布とphc
gqcal(delta)
phc01(seq(0.0,1.2,0.1),delta, cc="gtc",byoga="no")
gqcal(deltaD)
phc01(seq(0.0,1.2,0.1),deltaD,cc="gtc",byoga="no")

#2) 閾上率と差得点の閾上率
 ikijyori2(seq(0,3,0.5),out0803,byoga="no",dedits=2)
Dikijyori2(seq(0,3,0.5),out0803,byoga="no",dedits=2)

#3) 対応ある2群の平均値差の検定
t.test(w1,w2,paired=T);                        #t検定

