#####################################################################
#第10章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表10.2 鏡映描写実験の群ごとの15 試行目のタイムと逸脱数
(鏡映描写01<-read.csv("./scrJ/鏡映描写01.csv", header = TRUE))
(x1<-鏡映描写01[鏡映描写01$group==1,1])
(x2<-鏡映描写01[鏡映描写01$group==2,1])
(x3<-鏡映描写01[鏡映描写01$group==3,1])
n1<-length(x1);n2<-length(x2);n3<-length(x3);

#図10.2　ボックスプロットによる3つの群の分布の相違
y<-c(x1,x2,x3)
群<-c(rep("1",n1),rep("2",n2),rep("3",n3))
boxplot(y~群,cex.axis=2.0, cex.lab=2.0, ylab="")
#dev.copy2eps(file="z0503.eps",family="Japan1")

#表10.3 平均・分散・標準偏差
round(apply(cbind(y,x1,x2,x3),2,mean),2)
round(apply(cbind(y,x1,x2,x3),2,van ),2)
round(sqrt(apply(cbind(y,x1,x2,x3),2,van )),2)

#１要因実験の推測
A<-c(rep(1,n1),rep(2,n2),rep(3,n3))    #水準の指定
out1001<-E1Ind(y,A,prior=T,mL=0, mH=100, sL=0, sH=50)
#save(out1001,  file="./scrJ/obje/out1001")
#load(file="./scrJ/obje/out1001"); #予めMCMCした結果をロード

#乱数の取り出し
muA<-out1001$muA;sigmaA<-out1001$sigmaA;sigmaE<-out1001$sigmaE;
mu<-out1001$mu;aj<-out1001$aj;U2<-out1001$U2; eta2<-out1001$eta2

#表10.4 母数の推定結果
gqcal(cbind(muA,sigmaE),1)

#表10.5 全平均と水準効果の推定結果
gqcal(cbind(mu,aj),1)

#図10.3　水準の効果の事後分布の箱ひげ図
size<-nrow(mu);              #乱数数
yy<-aj[,1]; for (i in 2:3){yy<-c(yy,aj[,i])};
boxplot(yy~rep(c("対照","非利き手","利き手"),each=size)
       ,ylab="",xlab="群",cex.axis=2.0, cex.lab=2.0)
abline(h=0.0,lwd=1.0, lty=3)
#dev.copy2eps(file="z0501.eps",family="Japan1")

#10.3.2 データにおける分散の分解
(sy2<-van(鏡映描写01$time));                                #全分散
(tm<-mean(鏡映描写01$time));                                #全平均

#要因分散・群間分散                                (10.16)式
(sa2<-((mean(x1)-tm)^2+(mean(x2)-tm)^2+(mean(x3)-tm)^2)/3); 

#誤差分散・群内分散                                (10.17)式,(10.18)式
(se2<-(van(x1)+van(x2)+van(x3))/3);

#要因分散と誤差分散の和が全分散に等しいことの確認  (10.19)式 (10.20)式
sa2+se2;  

#誤差分散・群内分散は以下のように計算してもよい
(se2<-(sum((x1-mean(x1))^2)+sum((x2-mean(x2))^2)+sum((x3-mean(x3))^2))/90)

#10.4 要因と水準の考察
eta2<-sigmaA^2/(sigmaA^2+sigmaE^2);           #分散説明率・決定係数

#表10.6 群間標準偏差の数値要約とphcテーブル
gqcal(sigmaA)
phc01(seq(1.0,4.0,0.5), sigmaA,0,cc="gtc", byoga="no");
phc01(seq(1.0,4.0,0.5), sigmaA,0,cc="rope",byoga="no");#rope

#表10.7  分散説明率の数値要約とphcテーブル
gqcal(eta2)
phc01(seq(0,0.06,0.01), eta2  ,0,cc="gtc", byoga="no");
phc01(seq(0,0.06,0.01), eta2  ,0,cc="rope",byoga="no");#rope

#図10.4  群間標準偏差と分散説明率のphc 曲線
par(mfrow=c(2,1))
phc01(seq(1.0,8.0,0.05),sigmaA,0,cc="gtc",byoga="yes",xlab="群間標準偏差");
phc01(seq(0,0.25,0.01), eta2  ,0,cc="gtc",byoga="yes",xlab="分散説明率");
par(mfrow=c(1,1))
#dev.copy2eps(file="z1004as.eps",family="Japan1")


# phc02(c=0,ext,cc="gtc",digits=3) 複数の水準間にc以上の差がある確率の行列
#c   スカラー　基準点　
#ext 行に乱数、列に母数をもつ行列
#cc="gtc"の場合は、行の母数ー列の母数 >cであり、
#  "rope"の場合はabs(行の母数ー列の母数)<cであり、
#      それ以外は、行の母数ー列の母数 <c
#表10.8  行j の水準が列j′ の水準よりc より大きい確率
phc02(c=0.0,muA)
phc02(c=1.0,muA)
phc02(c=2.0,muA)

#表10.9 第1 群と第2 群の差(仮説A) に関する考察を与える分析
E1between(out1001,2,1,2,cr1=c(0,0.5,1.0))

#表10.10 第2 群と第3 群の差(仮説B) に関する考察を与える分析
E1between(out1001,2,2,3,cr1=c(0,0.5,1.0))

# conjunctive(　)基準点ベクトルc1,c2の下での2つの研究仮説が同時に成り立つ確率
# x:a列の乱数によって構成された行列[,a](0,1ではなく乱数)
# IJ:2*2の行列,IJ[1,1]-IJ[1,2] かつ IJ[2,1]-IJ[2,2]か成り立つ確率を評価する
# c1,c2:それぞれの基準点のベクトル
#表10.11  仮説C に関する連言命題が正しい確率
conjunctive(muA,rbind(c(1,2),c(2,3)),c1=seq(0,2.5,0.5),c2=seq(0,2.5,0.5),3)


###1要因分散分析によるF検定
print(summary(aov(y ~ A)))

########################################################################
#第10章 10.6 実習課題 p.151

#表10.12の「知覚時間」データ入力
#対照
x1<-c(31.43,31.09,33.38,30.49,29.62,35.40,32.58,28.96,29.43,28.52,
     25.39,32.68,30.51,30.15,32.33,30.43,32.50,32.07,32.35,31.57)
#聴音
x2<-c(32.30,34.24,28.10,33.40,37.71,31.62,31.37,35.85,32.33,34.04,
     34.96,31.43,35.28,30.19,35.09,33.38,31.49,28.44,32.12,31.81)
#音読
x3<-c(31.62,37.04,33.76,30.01,34.18,33.08,28.77,33.90,28.06,37.54,
     33.89,32.23,35.95,36.68,33.57,30.87,32.20,29.98,33.08,35.12)
n1<-length(x1);n2<-length(x2);n3<-length(x3);
y<-c(x1,x2,x3)
A<-c(rep(1,n1),rep(2,n2),rep(3,n3))    #水準の指定
out1002<-E1Ind(y,A,prior=T,mL=0, mH=100, sL=0, sH=50)
#save(out1002,  file="./scrJ/obje/out1002")
#load(file="./scrJ/obje/out1002"); #予めMCMCした結果をロード

# 以降の例示のスクリプトは割愛する

########################################################################
#自習　第10章 10.7 実践課題　p.152
#表10.13の「マウスの体重増のデータ(g)」
#1) 3つの飼育で体重が増加しやすい条件の順番を点推定値で報告せよ。
#2) 飼育条件の違いは、体重の増加の違いを何パーセント説明しているか。
#3) LL条件とLM条件の増加体重で、母平均に 0g,2g,4g 以上差のあるという確信の確率はどれほどか。
#4) 体重増加の一番大きい群と小さい群の違いを詳細を述べよ。閾上率は0g,2g,4gで計算せよ。
#5) 点推定値の順番に母平均に差があるという連言命題が正しい確信の確率はどれほどか。

x1<-c(05.02, 06.67, 08.17, 02.79, 08.13, 06.34, 06.32, 03.97)
x2<-c(09.89, 09.58, 11.20, 09.05, 12.33, 09.39, 10.88, 09.37, 17.40)
x3<-c(10.20, 07.29, 07.57, 03.42, 05.82, 10.92, 05.21, 13.47, 08.64, 06.05)
y<-c(x1,x2,x3)
A<-c(rep(1,8),rep(2,9),rep(3,10))
out1003<-E1Ind(y,A,prior=T,mL=0, mH=50, sL=0, sH=50)
#save(out1003,  file="./scrJ/obje/out1003")
#load(file="./scrJ/obje/out1003"); #予めMCMCした結果をロード

# 1) 2)
gqcal(out1003$ext[,1:17])

# 3)
#表10.8  行j の水準が列j′ の水準よりc より大きい確率
phc02(c=0.0,out1003$muA)
phc02(c=2.0,out1003$muA)
phc02(c=4.0,out1003$muA)

# 4)
E1between(out1003,2,2,1,cr1=c(0.0,2.0,4.0))

# 5)
conjunctive(out1003$muA,rbind(c(2,3),c(3,1)),
      c1=seq(0,0.5,0.1),c2=seq(0,0.5,0.1),2)


########################################################################
