﻿#######################################################################
#第11章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#表11.1   2 要因の「心理学的知覚実験」のS1 氏のデータ(単位：秒)
y1<-c(
   28.10,31.67,33.60,25.37,32.03,32.21,29.62,29.69,29.65,28.86,
   31.35,30.10,30.64,32.65,34.80,32.24,31.27,30.31,30.49,38.30,
   33.32,31.82,31.94,34.10,31.34,29.52,34.38,30.54,32.96,30.75,
   33.95,30.16,29.60,30.10,27.39,28.50,26.07,28.08,30.59,30.18,
   34.48,28.44,28.95,30.33,28.61,28.68,28.34,28.00,29.74,29.81,
   28.17,31.10,29.84,30.06,32.11,33.85,36.45,30.64,36.35,29.72,
   29.58,34.12,27.92,26.39,27.98,32.27,25.27,31.28,31.19,28.81,
   31.92,30.81,31.02,33.46,36.87,31.53,28.56,30.16,32.52,31.14)
A <- rep(1:4,each=10,times=2)       #要因Aの水準の指定
B <- rep(1:2,each=40)               #要因Bの水準の指定

#2要因実験の推測 S1 氏の分析
out1101<-E2Ind(y1,A,B,prior=T,mL=0, mH=100, sL=0, sH=50)
#save(out1101,  file="./scrJ/obje/out1101")
#load(file="./scrJ/obje/out1101"); #予めMCMCした結果をロード

############### 11.2 推測例1 (交互作用の分析) #########################

#表11.2 S1 氏のデータの平均と標準偏差
#図11.1 S1 氏のデータの平均値プロット
# mean_sd_plot(　) 2要因実験のセル平均・標準偏差・平均をプロットする関数
#y:測定値ベクトル
#A:水準の指定（2水準以上）
#B:水準の指定（2水準）
mean_sd_plot(y1,A,B,ylab="知覚された30秒",xlab="対照・聴音・音読・運動")


#表11.3  母数の推定結果(S1)
gqcal(out1101$mu,        2)    ;#(11.1)式
gqcal(out1101$muA,       2)    ;#(11.2)式
gqcal(out1101$muB[,1],   2)    ;#(11.3)式
gqcal(out1101$muAB[,1:4],2)    ;#(11.4)式


#表11.4 効果の大きさに関する生成量の推定結果
gqcal(out1101$sigmaA, 3)    ;#(11.15)式
gqcal(out1101$sigmaB, 3)    ;#(11.15)式
gqcal(out1101$sigmaAB,3)    ;#(11.15)式
gqcal(out1101$sigmaE, 2)    ;#(11.15)式
gqcal(out1101$eta2A,  3)    ;#要因Aの主効果の説明率
gqcal(out1101$eta2B,  3)    ;#要因Bの主効果の説明率
gqcal(out1101$eta2AB, 3)    ;#要因ABの交互作用の説明率
gqcal(out1101$eta2T,  3)    ;#要因全体の説明率


#表11.5 セル平均の推定結果(教科書とは出力の順番が異なる)(11.8)式(11.9)式
gqcal(out1101$cellmean,2)


# phc02(c=0,ext,cc="gtc",digits=3) 複数の水準間にc以上の差がある確率の行列
#c   スカラー　基準点　
#ext 行に乱数、列に母数をもつ行列
#cc="gtc"の場合は、行の母数ー列の母数 >cであり、
#  "rope"の場合はabs(行の母数ー列の母数)<cであり、
#      それ以外は、行の母数ー列の母数 <c
#表11.6 実質的に差があるための必要条件の確認　phc(μjk ? μj′k′ > 0)
phc02(c=0.0,out1101$cellmean,cc="gtc",3)

# E2between(　)２つのセルの比較（閾上率の基準点はベクトルで指定）
#x:クラス 'E2Ind'$cellmeanのオブジェクト
#I=1: 整数、平均値の大きいセル
#J=2: 整数、平均値の小さいセル
#cr1: 閾上率の基準点をベクトルで指定
#degits=3 : 小数の丸め
#表11.7 「平常時」における「聴音条件」と「運動条件」の差の推測結果
colnames(out1101$cellmean)
E2between(out1101,I=2,J=4,cr1=c(0,1,2),degits=3)

############### 11.4 推測例2 (3 水準以上の主効果の分析)###############

#表11.8   2 要因の「心理学的知覚実験」のS2 氏のデータ(単位：秒)
y2<-c(
   33.00,31.92,27.85,30.99,31.61,30.50,31.06,29.48,33.08,32.55,
   34.89,32.33,31.98,34.22,35.48,27.54,35.53,28.57,29.57,33.94,
   36.30,30.51,33.70,28.77,32.60,35.11,29.35,31.99,33.22,33.04,
   27.34,33.40,24.63,27.24,28.27,31.85,25.05,29.04,31.29,30.20,
   29.38,29.80,31.28,31.54,31.83,30.50,27.22,30.06,29.61,35.33,
   35.69,35.02,31.94,33.98,30.38,26.21,34.91,33.36,31.37,33.49,
   30.00,31.23,30.09,34.73,35.43,33.44,34.65,33.35,30.41,33.41,
   26.35,28.61,29.52,27.63,27.05,33.32,29.85,34.44,28.52,32.40)

#2要因実験の推測 S2 氏の分析
out1102<-E2Ind(y2,A,B,prior=T,mL=0, mH=100, sL=0, sH=50)
#save(out1102,  file="./scrJ/obje/out1102")
#load(file="./scrJ/obje/out1102"); #予めMCMCした結果をロード

#       S2 氏のデータの平均と標準偏差
#図11.2 S2 氏のデータの平均値プロット
mean_sd_plot(y2,A,B,ylab="知覚された30秒",xlab="対照・聴音・音読・運動")

#表11.9 母数の推定結果(S2)
gqcal(out1102$mu,        2)    ;#(11.1)式
gqcal(out1102$muA,       2)    ;#(11.2)式
gqcal(out1102$muB[,1],   2)    ;#(11.3)式
gqcal(out1102$muAB[,1:4],2)    ;#(11.4)式

#表11.10 効果の大きさに関する生成量の推定結果(S2)
gqcal(out1102$eta2A,  3)    ;#要因Aの主効果の説明率
gqcal(out1102$eta2B,  3)    ;#要因Bの主効果の説明率
gqcal(out1102$eta2AB, 3)    ;#要因ABの交互作用の説明率
gqcal(out1102$eta2T,  3)    ;#要因全体の説明率


#表11.11 phc(aj - aj′> c)   要因Aのどの水準の間に違いがあるのか
phc02(c=0.0,out1102$muA,cc="gtc",3)
phc02(c=1.0,out1102$muA,cc="gtc",3)

#表11.12 対照条件とその他の条件との差に関するphcテーブル
phc01(seq(0,1.2,0.2),out1102$muA[,2],out1102$muA[,1],cc="gtc", byoga="no")
phc01(seq(0,1.2,0.2),out1102$muA[,3],out1102$muA[,1],cc="gtc", byoga="no")
phc01(seq(0,1.2,0.2),out1102$muA[,1],out1102$muA[,4],cc="gtc", byoga="no")

############### 11.5 推測例3 (2 水準の主効果の分析)####################

#表11.13  2 要因の「心理学的知覚実験」のS2 氏のデータ(単位：秒)
y3<-c(
   35.24,31.29,31.00,32.23,30.13,26.27,30.71,29.88,31.11,26.99,
   28.73,31.34,32.09,33.68,31.60,32.17,29.54,28.75,29.57,26.70,
   29.59,30.51,32.05,28.99,28.10,31.29,28.48,30.80,33.88,33.52,
   34.34,29.29,30.00,33.31,27.98,29.23,32.34,30.54,31.82,31.85,
   27.88,30.26,29.96,24.01,29.48,34.10,30.69,27.32,26.67,33.97,
   27.20,30.14,31.62,29.46,29.19,29.18,31.26,28.61,26.66,25.21,
   28.52,29.13,26.07,30.27,27.26,26.49,30.62,29.11,29.28,30.80,
   32.03,32.48,28.64,24.34,29.19,25.09,35.23,24.04,30.39,31.51)

#2要因実験の推測 S3 氏の分析
out1103<-E2Ind(y3,A,B,prior=T,mL=0, mH=100, sL=0, sH=50)
#save(out1103,  file="./scrJ/obje/out1103")
#load(file="./scrJ/obje/out1103"); #予めMCMCした結果をロード

#       S3 氏のデータの平均と標準偏差
#図11.3 S3 氏のデータの平均値プロット
mean_sd_plot(y3,A,B,ylab="知覚された30秒",xlab="対照・聴音・音読・運動")

#表11.14 母数の推定結果(S3)
gqcal(out1103$mu,        2)    ;#(11.1)式
gqcal(out1103$muA,       2)    ;#(11.2)式
gqcal(out1103$muB[,1],   2)    ;#(11.3)式
gqcal(out1103$muAB[,1:4],2)    ;#(11.4)式

#表11.15 効果の大きさに関する生成量の推定結果(S3)（説明率の数値要約）
gqcal(out1103$eta2B,  3)    ;

#表11.15 効果の大きさに関する生成量の推定結果(S3)（要因Bのphcテーブル）
phc01(seq(0,1.2,0.2),out1103$muB[,1],out1103$muB[,2],cc="gtc", byoga="no")

########################################################################

#自習
#表5.16 走者の有無による選手Ｅの球種別の球速
A<-c(rep(1,49),rep(2,49))
B<-c(rep(1,10),rep(2,8),rep(3,7),rep(4,9),rep(5,8),rep(6,7),
     rep(1,10),rep(2,8),rep(3,7),rep(4,9),rep(5,8),rep(6,7))
y<-c(140,146,149,136,147,147,143,143,143,141,
139,136,136,140,135,132,140,134,
123,127,131,130,138,128,129,
115,120,118,118,121,124,129,119,128,
128,124,123,121,122,126,131,122,
121,121,120,116,117,113,118,
143,141,142,145,149,145,143,141,142,155,
138,134,142,136,135,136,131,133,
131,128,128,128,127,130,130,
117,125,132,122,119,122,129,117,127,
117,120,124,122,122,122,118,122,
119,125,122,116,119,113,122)
a<-length(unique(A))
b<-length(unique(B))

out1104<-E2Ind(y,A,B,prior=T,mL=0, mH=1000, sL=0, sH=500)
#save(out1104,  file="./scrJ/obje/out1104")
#load(file="./scrJ/obje/out1104"); #予めMCMCした結果をロード

#1)2要因実験のセル平均・標準偏差を求め、平均をプロットし解釈しなさい。
#  要因の説明力の目安もつけなさい。
#  A(a=2)とB(b=6)なので、知覚時間とは、逆に指定していることに注意する
#2) μ, a_{1}, b_{1}, ..... b_{6}, ab_{15},ab_{25}
#   （５番目はスライダー）の点推定値を解釈しなさい。

mean_sd_plot(y,B,A,ylab="球速",
    xlab="ストレート,カットボール,フォーク,チェンジアップ,スライダー,カーブ")

gqcal(out1104$ext[,1:41],3)

#3) η_{A}^{2}, η_{B}^{2}, η_{AB}^{2} を解釈し、
#   このデータが３つの分析パタンの何番目になるのかを判断しなさい。
#   出力は　gqcal(out1104$ext[,1:41],3)　に含まれている


#4) フォーク(j=3)とチェンジアップ(j=4)の水準間に差のある確率を求めなさい。基準点としては、5km/時,10km/時 で計算。
#phc(aj - aj′> c)   要因Bのどの水準の間に違いがあるのか
phc02(c=5.0, out1104$muB,cc="gtc",3)
phc02(c=10.0,out1104$muB,cc="gtc",3)

#5) 走者がいないときのチェンジアップ(j=4)とカーブ(j=6)の違いを平均値差、
#　　デルタ・非重複率、閾上率（0km/時, 1km/時, 2km/時, 3km/時）の観点から、
#　　解釈しなさい。（特に興味のある２セルの比較）
#"cellmean24" と "cellmean26"の比較
colnames(out1104$cellmean);              #8列目と12列目の比較をおこなう
E2between(out1104,degits=3,I=8,J=12,cr1=c(0,1,2,3))

