﻿########################################################################
#第12章
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

#########12.3 比率の推測(1つの2項分布)################################

#知事の支持率
  x1 <- 305                               #正反応数 
  n1 <- 500                               #データ数 

#比率の推測(1つの2項分布)
out1201<-Bi01(x1,n1)
#save(out1201,  file="./scrJ/obje/out1201")
#load(file="./scrJ/obje/out1201"); #予めMCMCした結果をロード

#表12.1 比率の事後分布と予測分布の数値要約
#表12.2 「知事の支持率」のオッズの事後分布の数値要約
gqcal(out1201$ext[,1:3])

#図12.1 母比率とodds のphc 曲線
par(mfrow=c(2,1))
phc01(seq(0.5,0.7,0.01),out1201$theta,0,cc="gtc",byoga="yes",xlab="母比率");
phc01(seq(1.2,1.9,0.01),out1201$Odds ,0,cc="gtc",byoga="yes",xlab="odds");
par(mfrow=c(1,1))
#dev.copy2eps(file="z1201.eps",family="Japan1")

#表12.3 母比率とodds のphc テーブル
phc01(seq(0.55,0.61,0.01),out1201$theta,0,cc="gtc",byoga="no");
phc01(seq(1.28,1.40,0.02),out1201$Odds ,0,cc="gtc",byoga="no");

##########12.4  2×2のクロス表の推測(2 つの2 項分布の積)#################

#ブランド認知問題1 
#表12.4  ブランド認知率調査の結果(人数)
  x2 <- c(85,31)                          #正反応数 
  n2 <- c(123,121)                        #データ数 

#2×2のクロス表の推測(2 つの2 項分布の積)
out1202<-Bi02(x2,n2)
#save(out1202,  file="./scrJ/obje/out1202")
#load(file="./scrJ/obje/out1202"); #予めMCMCした結果をロード

#表12.5「ブランド認知問題1」の母数と生成量の事後分布の数値要約
gqcal(out1202$ext[,1:9])

#phc曲線　教科書にはない
par(mfrow=c(3,1))
phc01(seq(0.3,0.55,0.02),out1202$p_sa,0,cc="gtc",byoga="yes",xlab="母比率の差")
phc01(seq(1.8,3.8 ,0.02),out1202$p_hi,0,cc="gtc",byoga="yes",xlab="母比率の比")
phc01(seq(3,12.0,0.02),out1202$Odds_hi,0,cc="gtc",byoga="yes",xlab="オッズ比")
par(mfrow=c(1,1))

#表12.6 比率の差・比率の比・オッズ比 のphc テーブル
phc01(seq(0.28,0.40,0.02),out1202$p_sa    ,0,cc="gtc",byoga="no");
phc01(seq(1.8,2.4,0.1),   out1202$p_hi    ,0,cc="gtc",byoga="no");
phc01(seq(3.0,4.5,0.25),  out1202$Odds_hi ,0,cc="gtc",byoga="no");

########12.5  g×2 のクロス表の推測(g 個の2 項分布の積)#####################

#表12.7 お年玉があったか否か(人数)
  x3 <- c(42,31,29,20)                     #正反応数 
  n3 <- c(51,49,50,48)                     #データ数 
  g <- length(x3)                          #群の数

#g×2 のクロス表の推測(g 個の2 項分布の積)
out1203<-Bi03(x3,n3)
#save(out1203,  file="./scrJ/obje/out1203")
#load(file="./scrJ/obje/out1203"); #予めMCMCした結果をロード

#表12.8 「お年玉問題」の母数の事後分布の数値要約
gqcal(out1203$p)

#表12.9 行i のカテゴリが列j のカテゴリより比率が大きい確率
phc02(0,out1203$p,cc="gtc",3)

#生成量の作成
p_sa13  <-out1203$p[,1]-out1203$p[,3]
p_hi13  <-out1203$p[,1]/out1203$p[,3]
Odds_hi13<-(out1203$p[,1]*(1-out1203$p[,3]))/(out1203$p[,3]*(1-out1203$p[,1]))

#表12.10 高校生と大学生(後) の比較
gqcal(p_sa13  );  #比率の差
gqcal(p_hi13  );  #比率の比
gqcal(Odds_hi13); #オッズ比

#図12.2 母比率の差・母比率の比・Odds比 のphc 曲線
par(mfrow=c(3,1))
phc01(seq(0.05,0.45,0.02),p_sa13   ,0,cc="gtc",byoga="yes",xlab="母比率の差");
phc01(seq(1.00,2.00,0.05),p_hi13   ,0,cc="gtc",byoga="yes",xlab="母比率の比");
phc01(seq(1.00,8.00,0.25),Odds_hi13,0,cc="gtc",byoga="yes",xlab="オッズ比");
par(mfrow=c(1,1))
#dev.copy2eps(file="z1202.eps",family="Japan1")


########################################################################
実習課題

割愛します。

########################################################################
#自習 第12章 12.9 実践問題 p.183 ファイザー社のコロナワクチン

#表12.12 臨床試験の概要
  x4 <- c(8,162)                          #発症者数 
  n4 <- c(2214,2222)                      #被検者数 

#2つの2項分布に関する推測
out1204<-Bi02(x4,n4)
#save(out1204,  file="./scrJ/obje/out1204")
#load(file="./scrJ/obje/out1204"); #予めMCMCした結果をロード

#1)ワクチンを打った群と打たない群の母比率の事後分布と、phcを計算して考察せよ。
gqcal(out1204$ext[,1:9])
phc01(seq(0.001,0.01,0.0005),out1204$p[,1],0,cc="ltc",byoga="yes",
      xlab="実験群母比率");
phc01(seq(0.001,0.01,0.001),out1204$p[,1],0,cc="ltc",byoga="no",
      xlab="実験群母比率");
phc01(seq(0.05,0.1,0.001),out1204$p[,2],0,cc="ltc",byoga="yes",
      xlab="対照群母比率");
phc01(seq(0.05,0.1,0.01),out1204$p[,2],0,cc="ltc",byoga="no",
      xlab="対照群母比率");

#2)ワクチンを打つことによってリスクは、どの程度軽減するか、リスク比の事後分布、phcを計算して考察せよ。
phc01(seq(0.01,0.1,0.001),out1204$p_hi,0,cc="ltc",byoga="yes",xlab="リスク比");
phc01(seq(0.01,0.1,0.01),out1204$p_hi,0,cc="ltc",byoga="no",xlab="リスク比");
phc01(seq(1,41,2),1/out1204$p_hi,0,cc="gtc",byoga="yes",xlab="リスク比の逆数");
phc01(seq(2,20,2),1/out1204$p_hi,0,cc="gtc",byoga="no",xlab="リスク比の逆数");

#3) ワクチンの効果を表す指標としては、入門的な統計学の教科書では解説されない医学的指標である
#   有効率(=1-リスク比)が用いられることが多い。有効率は
#   「ワクチン接種によって、接種せずに発症したはずの何％が発症せずに済むか」を示した指標である。
#   有効率を生成量として構成し、事後分布と、phcを計算して考察せよ。
yuko_ritu<- 1-out1204$p_hi 
gqcal(yuko_ritu)
phc01(seq(0.9,1.0,0.05),yuko_ritu,0,cc="gtc",byoga="yes",xlab="有効率");
phc01(seq(0.9,1.0,0.01),yuko_ritu,0,cc="gtc",byoga="no",xlab="有効率");




