﻿########################################################################
#第13章用スクリプト(多項分布の推測)
# Working directoryが 'toyoda' であることの確認
(n_wd<-getwd())                        #working directoryの確認
(setwd('./scrJ'))
source('../myfunc/myfunc.R')      #自作関数の読み込み
(setwd(n_wd))
   library(cmdstanr)              #パッケージcmdstanrの呼び出し
   library(posterior)             #パッケージposteriorの呼び出し

###########13.2   比率の推測(1 つの多項分布)#####################

########ペット問題 
#表13.1 初めて飼ったペット(人数)
  x1 <- c(32,29,18,15,10)


#カテゴリ数がkの比率の推測
out1301<-Mu01(x1)
#save(out1301,  file="./scrJ/obje/out1301")
#load(file="./scrJ/obje/out1301"); #予めMCMCした結果をロード

#表13.2 「ペット問題」の比率の事後分布
gqcal(out1301$pi)                 ; #

#表13.3 行i のカテゴリの比率が列j のカテゴリの比率より大きい確率
phc02(c=0.0 ,out1301$pi,cc="gtc") ; #

#図13.1 比率の差と比率の比のphc 曲線(犬と鳥の比較)
par(mfrow=c(2,1))
phc01(seq(0,0.25,0.01),out1301$pi[,1],out1301$pi[,4],cc="gtc",byoga="yes",xlab="比率の差 p1-p4");
phc01(seq(0.0,1.0,0.02),out1301$pi[,4]/out1301$pi[,1],cc="ltc",byoga="yes",xlab="比率の比 p4/p1");
par(mfrow=c(1,1))
#dev.copy2eps(file="z1301.eps",family="Japan1")

#表13.4 比率の差と比率の比のphc テーブル(犬と鳥の比較)
phc01(seq(0.02,0.08,0.01),out1301$pi[,1],out1301$pi[,4],cc="gtc",byoga="no");
phc01(seq(0.7, 1.0 ,0.05),out1301$pi[,4]/out1301$pi[,1],cc="ltc",byoga="no");

################13.3   対応ある2×2のクロス表の推測#########################

########ブランド認知問題2
#表13.5  2つのブランドの認知のクロス表(人数)
  x2 <- matrix(c(
       70,30,
       28,72),2,2,T)
apply(x2,1,"sum");apply(x2,2,"sum")

#表13.8  2つのブランドの認知の標本比率
x2/200;
apply(x2,1,"sum")/200;apply(x2,2,"sum")/200


#対応ある2×2のクロス表の分析
out1302<-Mu02(x2)
#save(out1302,  file="./scrJ/obje/out1302")
#load(file="./scrJ/obje/out1302"); #予めMCMCした結果をロード

#表13.9 「ブランド認知問題2」の母数の事後分布
#pim: i行j列の母比率(a × b)
gqcal(out1302$pim)

#表13.12 eij・V の事後分布の要約統計量(上段のブランド)
#res: ピアソン残差(a × b) V: クラメルの連関係数
gqcal(out1302$res)
gqcal(out1302$V)

#表13.13 同時確率と周辺確率の積との比Lij の事後分布の要約統計量
#L : 同時確率と周辺確率の積との比
gqcal(out1302$L)

#表13.14 L11 とL12 のphc テーブル
phc01(seq(1.24,1.30,0.01),out1302$L[,1],cc="gtc",byoga="no");
phc01(seq(0.69,0.75,0.01),out1302$L[,3],cc="ltc",byoga="no");


######トランプ
#表13.10 トランプのクロス表
  x3 <- matrix(c(
       20,20,
        6, 6),2,2,T)
apply(x3,1,"sum");apply(x3,2,"sum")

#表13.11 トランプのクロス表の確率
round(x3/52,3)
round(apply(x3,1,"sum")/52,3)
round(apply(x3,2,"sum")/52,3)

#対応ある2×2のクロス表の分析
out1303<-Mu02(x3)
#save(out1303,  file="./scrJ/obje/out1303")
#load(file="./scrJ/obje/out1303"); #予めMCMCした結果をロード

#表13.12 eij・V の事後分布の要約統計量(下段のトランプ)
gqcal(out1303$res)
gqcal(out1303$V)

#表13.13 同時確率と周辺確率の積との比Lij の事後分布の要約統計量
gqcal(out1303$L)

############# 13.4  対応ある a×b のクロス表の推測 ####################
#####パスタ問題
#表13.15 パスタに選ばれたトッピング
  x4 <- matrix(c(
       19,  9,  6,
       10, 19,  5,
       15, 14, 18),3,3,T)
colnames(x4)<-c('バジル','トリュフ','なし')
rownames(x4)<-c('トマトの冷製','カルボナーラ','ペペロンチーノ')
x4
apply(x4,1,"sum");apply(x4,2,"sum");sum(x4)

#対応あるa×bのクロス表の分析
out1304<-Mu02(x4)
#save(out1304,  file="./scrJ/obje/out1304")
#load(file="./scrJ/obje/out1304"); #予めMCMCした結果をロード

#表13.18 「パスタ問題」のセルの同時確率(母数) の事後分布の数値要約
gqcal(out1304$pim)

#表13.19 「パスタ問題」のクラメルの連関係数と周辺確率の事後分布の数値要約
#pa: 第i行の周辺確率(a) pb: 第j列の周辺確率(b)
gqcal(out1304$V)
gqcal(out1304$pa)
gqcal(out1304$pb)

#表13.20 同時確率が周辺確率の積より大きい確率
#Up: ピアソン残差が0より大きい確率(a × b)
#Um: ピアソン残差が0以下の確率(a × b)
gqcal(out1304$Up)
gqcal(out1304$Um)

#表13.21 比率の比の事後分布の要約統計量(前半)
gqcal(out1304$L)

#表13.21 比率の比のphcテーブル(後半)
phc01(seq(1.10,1.40,0.05),out1304$L[,5],cc="gtc",byoga="no");
phc01(seq(1.10,1.40,0.05),out1304$L[,9],cc="gtc",byoga="no");

########################################################################

##自習. ２回来店した客が注文したワイン
##「はじめての統計データ分析」p158, 第６章 6.5.4 ワイン選択問題より
#あるレストランでメインの「料理」(子牛ロースト、パスタゴルゴンゾーラ、
#  舌平目ムニエル)に対して客がどんな「ワイン」(赤、ロゼ、白)を選んだのかを
#  集計した。「料理」と「ワイン」の連関を分析せよ。
#1) 表13.19の2行目を参考にして、クラメルの連関係数の事後分布を求め、
#      トッピングの例と比較しなさい。
#2) 表13.20を参考にして、どのセルが独立から実質的に隔たっているのか、
#       必要条件の確認をしなさい。
#3) 表13.21上表を参考にして、必要条件を満たしたと考えたセルに関して、
#       独立な状態からの乖離を考察しなさい。
#4) 表13.21下表を参考にして、独立な状態からの乖離が最大と最小のセルの
#        Lのphcテーブルを作成し、解釈しなさい。

x5 <- matrix(c(19,12, 6,
                8, 8, 4,
               15,19,18),3,3,T)
colnames(x5)<-c('子牛','パスタ','舌平目')
rownames(x5)<-c('赤','ロゼ','白')
x5
apply(x5,1,"sum");apply(x5,2,"sum");sum(x5)

#対応あるa×bのクロス表の分析
out1305<-Mu02(x5); 
#save(out1305,  file="./scrJ/obje/out1305")
#load(file="./scrJ/obje/out1305"); #予めMCMCした結果をロード

# 1) 
print("クラメルの連関係数")
gqcal(out1305$V)

# 2) 
gqcal(out1305$Up)
gqcal(out1305$Um)

# 3)
gqcal(out1305$L)

# 4)
phc01(seq(1.0,1.3,0.05),out1305$L[,9],cc="gtc",byoga="no"); #最大
phc01(seq(0.7,1.0,0.05),out1305$L[,7],cc="ltc",byoga="no"); #最小


########################################################################

